#include <dos.h>
/*#include <time.h>*/
#include <math.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define pi 3.141592653587
#define width 80
#define height 50
#define segs_a 6
#define segs_b 6
#define size_a 20
#define size_b 8

typedef struct
{
	int x;
	int y;
	int z;
} tpoint3d, *ppoint3d;

typedef struct
{
	int x;
	int y;
	int c;
} ttpoint, *ptpoint;

typedef struct
{
	int p1;
	int p2;
	int p3;
	int zcenter;
} tplane, *pplane;

#define float2fixed(i) ((int)(i)*256)
#define fixed2float(i) ((float)(i)/256)
#define swap(a, b, c) ((c)=(a), (a)=(b), (b)=(c))

char far *vmem = (char far *)MK_FP(0xb800, 2*width*height);

int sine[256];
char *scrbuf;
int x_sin, y_sin, z_sin;
int x_cos, y_cos, z_cos;
int x_ang=0;
int y_ang=0;
int z_ang=0;
tpoint3d toruspts[segs_a][segs_b];
tpoint3d rotatedpts[segs_a*segs_b];
tplane torusplanes[segs_a*segs_b*2];
int planelist[segs_a*segs_b*2];

void torus_init2()
{
	int i, j, k;
	float x, y, r;
	for (i=0; i<segs_a; i++)
	{
		for (j=0; j<segs_b; j++)
		{
			r = size_a + size_b*sin(j*pi*2/segs_b);
			toruspts[i][j].x = float2fixed(r*cos(i*pi*2/segs_a));
			toruspts[i][j].y = float2fixed(r*sin(i*pi*2/segs_a));
			toruspts[i][j].z = float2fixed(size_b*cos(j*pi*2/segs_b));	}}
	for (k=0, i=0; i<segs_a; i++)
		for (j=0; j<segs_b; j++)
		{
			torusplanes[k].p1 = i*segs_a+j;
			torusplanes[k].p2 = segs_a*((i+1)%segs_a)+j;
			torusplanes[k++].p3 = segs_a*((i+1)%segs_a)+((j+1)%segs_b);
			torusplanes[k].p1 = i*segs_a+j;
			torusplanes[k].p2 = segs_a*((i+1)%segs_a)+((j+1)%segs_b);
			torusplanes[k++].p3 = i*segs_a+((j+1)%segs_b);	}
}


void torus_init1()
{
	int i;
	for (i=0; i<256; i++) sine[i] = (int)(256*sin(i*pi/128));
}

/*
void init80x50()
{
	_AX = 0x0003;
	geninterrupt(0x10);
	_AX = 0x1112;
	_BL = 0x00;
	geninterrupt(0x10);
	_AX = 0x1003;
	_BL = 0x00;
	geninterrupt(0x10);
}
*/

int fixedmul(int a, int b)
{
	return ((long)a*(long)b)>>8;
}

void getsinecos()
{
	x_sin = sine[x_ang&255];
	y_sin = sine[y_ang&255];
	z_sin = sine[z_ang&255];
	x_cos = sine[(x_ang+64)&255];
	y_cos = sine[(y_ang+64)&255];
	z_cos = sine[(z_ang+64)&255];
}

void rotatepoint(ppoint3d src, ppoint3d dest)
{
	tpoint3d temp;
	temp.y = fixedmul(src->y, x_cos)-fixedmul(src->z, x_sin);
	temp.z = fixedmul(src->y, x_sin)+fixedmul(src->z, x_cos);
	dest->x = fixedmul(src->x, y_cos)-fixedmul(temp.z, y_sin);
	dest->z = fixedmul(src->x, y_sin)+fixedmul(temp.z, y_cos);
	temp.x = dest->x;
	temp.z = dest->z;
	dest->x = fixedmul(temp.x, z_cos)-fixedmul(temp.y, z_sin);
	dest->y = fixedmul(temp.x, z_sin)+fixedmul(temp.y, z_cos);
}

void projectpoint(ppoint3d src, ppoint3d dest)
{
	dest->z = src->z;
	dest->x = 40+(src->x/((src->z>>8)+256));
	dest->y = 25+(src->y/((src->z>>8)+256));
}

void swappage()
{
	unsigned th;
	th = FP_OFF(vmem)/2;
	while (!inp(0x3da)&8);
	outportb(0x3d4, 0x0c);
	outportb(0x3d5, th>>8);
	outportb(0x3d4, 0x0d);
	outportb(0x3d5, th);
	if (FP_OFF(vmem))
		vmem = (char far *)MK_FP(0xb800, 0x0000);
	else
		vmem = (char far *)MK_FP(0xb800, width*height*2);
}

char coltab[2][16]={
      0x00,0x00,0x01,0x00,0x01,0x01,0x10,0x11,
      0x19,0x91,0x99,0x9b,0xb9,0xbb,0xbf,0xfb,

      0x00,0x00,0x04,0x00,0x04,0x04,0x40,0x44,
      0x4c,0xc4,0xcc,0xce,0xec,0xee,0xef,0xfe
      };
char mde;

void innerloop(int xc1, int xc2, int dx1, int dx2,
               int rc,  int drc, int dc, int y1, int y2)
{
	char *dptr;
	char *d;
	int sx1, sx2, c;
	for (; y1<=y2; y1++)
	{
		sx1 = xc1>>8;
		sx2 = xc2>>8;
		c = rc+(mde<<8);
		if (y1>0) if (y1<50){d=scrbuf+(sx1+80*y1);
		for (; sx1<=sx2; sx1++)
                {
			*d++|=coltab[mde][(c>>8)&15];
			c+=dc;	}
                  }
		rc+=drc;
		xc1+=dx1;
		xc2+=dx2;	}
}

void poly_a(ptpoint p1, ptpoint p2, ptpoint p3)
{
	ptpoint temp;
	int xc1, xc2, dx1, dx2, rc, drc, dc;
	if (p2->x>p3->x) swap (p2, p3, temp);
	xc1 = xc2 = p1->x<<8;
	rc = p1->c;
	if (p2->y-p1->y)
	{
		dx1 = ((p2->x-p1->x)<<8)/(p2->y-p1->y);
		dx2 = ((p3->x-p1->x)<<8)/(p2->y-p1->y);
		drc = (p2->c-p1->c)/(p2->y-p1->y);	}
	if (p3->x-p2->x) dc = (p3->c-p2->c)/(p3->x-p2->x);
	innerloop(xc1, xc2, dx1, dx2, rc, drc, dc, p1->y, p2->y);
}

void poly_b(ptpoint p1, ptpoint p2, ptpoint p3)
{
	ptpoint temp;
	int xc1, xc2, dx1, dx2, rc, drc, dc;
	if (p1->x>p2->x) swap(p1, p2, temp);
	xc1 = p1->x<<8;
	xc2 = p2->x<<8;
	rc = p1->c;
	if (p3->y-p1->y)
	{
		dx1 = ((p3->x-p1->x)<<8)/(p3->y-p1->y);
		dx2 = ((p3->x-p2->x)<<8)/(p3->y-p1->y);
		drc = (p3->c-p1->c)/(p3->y-p1->y);	}
	if (p2->x-p1->x) dc = (p2->c-p1->c)/(p2->x-p1->x);
	innerloop(xc1, xc2, dx1, dx2, rc, drc, dc, p1->y, p3->y);
}

void triangle(ptpoint p1, ptpoint p2, ptpoint p3)
{
	ptpoint temp;
	ttpoint p4;
	if (p1->y>p2->y) swap(p1, p2, temp);
	if (p1->y>p3->y) swap(p1, p3, temp);
	if (p2->y>p3->y) swap(p2, p3, temp);

	if (p1->y==p3->y) return;
	if ((p1->y==p2->y)||(p2->y==p3->y))
	{
		if (p1->y==p2->y)
			poly_b(p1, p2, p3);
		else
			poly_a(p1, p2, p3);	}
	else
	{
		p4.c = (p1->c+(((p3->c-p1->c))/(p3->y-p1->y))*(p2->y-p1->y));
		p4.x = ((p1->x<<8)+((((p3->x-p1->x)<<8)/(p3->y-p1->y))*(p2->y-p1->y)))>>8;
		p4.y = p2->y-1;
		p2->y--;
		poly_a(p1, p2, &p4);
		p4.y++;
		p2->y++;
		poly_b(p2, &p4, p3);	}
}

int compareplanes(const void *a, const void *b)
{
	if (torusplanes[*(int *)a].zcenter>torusplanes[*(int *)b].zcenter)
		return -1;
	else
		if (torusplanes[*(int *)a].zcenter<torusplanes[*(int *)b].zcenter)
			return 1;
		else
			return 0;
}

/*
void calczcenters()
{
	int i;
	for (i=0; i<segs_a*segs_b*2; i++)
		torusplanes[i].zcenter = rotatedpts[torusplanes[i].p1].z+
					 rotatedpts[torusplanes[i].p2].z+
					 rotatedpts[torusplanes[i].p3].z;
}
*/

void do_torus(int zepra,char *scr)
{
	tpoint3d a;
	ttpoint p1, p2, p3;
	int i, j, k;
	int frames=0;
        scrbuf=scr;

                getsinecos();
		for (i=0, k=0; i<segs_a; i++)
			for (j=0; j<segs_b; j++)
			{
				rotatepoint(&toruspts[i][j], &a);
				projectpoint(&a, &rotatedpts[k++]);	}

		/*
		calczcenters();*/
		for (i=0; i<segs_a*segs_b*2; i++) planelist[i] = i;
		/*
		qsort(planelist, segs_a*segs_b*2, sizeof(int), compareplanes);
		*/

		for (i=0; i<segs_a*segs_b*2; i++)
		{
			p1.x = rotatedpts[torusplanes[planelist[i]].p1].x;
			p1.y = rotatedpts[torusplanes[planelist[i]].p1].y;
			p2.x = rotatedpts[torusplanes[planelist[i]].p2].x;
			p2.y = rotatedpts[torusplanes[planelist[i]].p2].y;
			p3.x = rotatedpts[torusplanes[planelist[i]].p3].x;
			p3.y = rotatedpts[torusplanes[planelist[i]].p3].y;
			p1.c = (rotatedpts[torusplanes[planelist[i]].p1].z+26768)>>2;
			p2.c = (rotatedpts[torusplanes[planelist[i]].p2].z+26768)>>2;
			p3.c = (rotatedpts[torusplanes[planelist[i]].p3].z+26768)>>2;

                        switch((zepra>>6)&7){
			case(0):mde=2-(i&1);break;
			case(1):mde=0;break;
			case(2):mde=2-(i&2);break;
			case(3):mde=1+((i&2)>>1);break;
			case(4):mde=(i&1);break;
			case(5):mde=2-(i&1);break;
			case(6):mde=(zepra+i)&3;break;
			case(7):mde=1;
			}

			if(mde<2)triangle(&p1, &p2, &p3);	}
		frames++;

                x_ang = (zepra*1)&255;
		y_ang = (zepra*3)&255;
		z_ang = (zepra*4)&255;

        /*}
        stop = clock();*/

/*      _AX = 0x0003;
        geninterrupt(0x10);

        printf("%f frames per second\n", frames*CLK_TCK/(stop-start));
*/
}


